// Vorl1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <mpi.h>

const int ROOT=0;

int main(int argc, char **argv) {
	int size, Pid;
	MPI_Status status;
	int retcode;
	int prev;
	int next;

	MPI_Init(&argc, &argv);

	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Comm_rank(MPI_COMM_WORLD, &Pid);

	//printf("size: %d   Pid: %d\n",size,Pid);
	int nr=0;
	int nrMax=0;
	switch (Pid) {
		case 0: nr=11; break;
		case 1: nr=13; break;
		case 2: nr=17; break;
		case 3: nr=4; break;
		default: puts("error"); break;
	}
	prev = (Pid-1+size)%size;
	next = (Pid+1)%size;

	if (Pid==ROOT) {
		MPI_Send(&nr, 1, MPI_INT, next,0,MPI_COMM_WORLD);

		retcode= MPI_Recv(&nrMax, 1, MPI_INT, prev, 0, 
				MPI_COMM_WORLD, &status);
		if (retcode!=MPI_SUCCESS) {
			puts("error in MPI_Recv");
			MPI_Finalize();
			return 1;
		}
		printf("Pid: %d  nrMax: %d\n",Pid,nrMax);
	}
	else {
		retcode= MPI_Recv(&nrMax, 1, MPI_INT, prev, 0, 
				MPI_COMM_WORLD, &status);
		if (retcode!=MPI_SUCCESS) {
			puts("error in MPI_Recv");
			MPI_Finalize();
			return 1;
		}
		if (nr>nrMax) nrMax=nr;
		printf("   Pid: %d  nrMax: %d\n",Pid,nrMax);
			
		MPI_Send(&nrMax, 1, MPI_INT, next,0,MPI_COMM_WORLD);
	}

	MPI_Finalize();
	return 0;
}
