// Wertetabelle.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#include <mpi.h>

const int ROOT=0;
const int MAX=100;

int main(int argc, char **argv) {
	int size, Pid;
	MPI_Status status;
	int retcode;
	int prev;
	int next;

	double x_root[MAX]; // root var.
	double y_root[MAX];
	double x=-1;  // client variablen
	double y=-1;

	MPI_Init(&argc, &argv);

	MPI_Comm_size(MPI_COMM_WORLD, &size);
	if (size>MAX) {
		printf("bitte maximal %d Task\n",MAX);
     	MPI_Finalize();
		return 1;
	}
	MPI_Comm_rank(MPI_COMM_WORLD, &Pid);

	int fktnr=0;

	/*if (Pid==ROOT) {
		fktnr=1;
		for (int i=1; i<size; i++) {
			MPI_Send(&fktnr, 1, MPI_INT, i,0,MPI_COMM_WORLD);
		}
	}
	else {
		retcode= MPI_Recv(&fktnr, 1, MPI_INT, ROOT, 0, 
			MPI_COMM_WORLD, &status);
		printf("Pid: %d  Nr: %d\n",Pid,fktnr);
	}*/

	if (Pid==ROOT) {
		fktnr=1;
	}
	MPI_Bcast(&fktnr, 1, MPI_INT, ROOT,MPI_COMM_WORLD);

	if (Pid!=ROOT) {
		//printf("Pid: %d  Nr: %d\n",Pid,fktnr);
	}
	
	if (Pid==ROOT) {
		for (int i=0; i<size; i++) {
			x_root[i]=i*0.5;
		}
	}
	int client_size=1;
	MPI_Scatter(x_root, client_size, MPI_DOUBLE, 
		&x, client_size, MPI_DOUBLE,ROOT, MPI_COMM_WORLD);

	//printf("Pid %d  x %f\n",Pid,x);

	switch (fktnr) {
		case 1: y=0.5*x*x*x-4*x*x+2*x+11.5;  
				break;
		case 2: y=2*x+4;  
				break;
		default:printf("Fehlerhafte case-Anweisung fktnr: %d\n",fktnr);
				MPI_Finalize();
				return 1;
	}
    //printf("   Pid:%d   x: %f   y: %f\n",Pid, x, y);

	client_size=1;
	retcode = MPI_Gather(&y, client_size,MPI_DOUBLE,
		y_root, client_size,MPI_DOUBLE,ROOT, 
		MPI_COMM_WORLD);
	if ( retcode!= MPI_SUCCESS) {
		puts("Fehler beim Aufruf von Gather");
	}

	if(Pid==ROOT) {
		for (int i=0; i<size; i++) {
			printf("    i:%d   y(i): %f\n",i, y_root[i]);
		}
	}

	double ymax=0;
	client_size=1;
	retcode=MPI_Reduce(&y,&ymax,client_size, MPI_DOUBLE,
		MPI_MAX, ROOT, MPI_COMM_WORLD);
	if ( retcode!= MPI_SUCCESS) {
		puts("Fehler beim Aufruf von Max");
	}

	if(Pid==ROOT) {
    	printf("    ymax: %f\n",ymax);
	}

	double ysum=0;
	client_size=1;
	retcode=MPI_Reduce(&y,&ysum,client_size, MPI_DOUBLE,
		MPI_SUM, ROOT, MPI_COMM_WORLD);
	if ( retcode!= MPI_SUCCESS) {
		puts("Fehler beim Aufruf von Max");
	}

	if(Pid==ROOT) {
    	printf("    ysum: %f\n",ysum);
	}

	MPI_Finalize();
	return 0;
}
